{$M 30000,20000,20000}

Program HitUsys;

(*  *)
(* Creates USERS.SYS from within a Batch File       (c) 1993 Hi.T.Moonweed *)
(*  *)
(* Last Revision: 05-31-93                                                 *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*  *)

{                           COMPILER DIRECTIVES                             }

{$A+}                   { Word Align Data            }
{$S+}                   { Stack Checking Off         }
{$R-}                   { Range Checking Off         }
{$L-}                   { Local Debug shit off       }
{$D-}                   { Debug Info Off             }
{$V-}                   { Relaxed VarString Checking }
{$F+}                   { Force Far Calls!           }
{$B-}                   { Short Circuit Boolean      }
{$O-}                   { Overlays Off               }

(* ----------------------------------------------------------------------- *)

Uses MiniCrt,        { Bios CRT Unit                                        }
     Dos,            { Dos Functions                                        }
     Tools,          { Various Utils                                        }
     DosMem,         { Improved Getmem                                      }
     Bufio,          { Buffered Input/Output                                }
     Mdosio,         { MSDos Input/Output                                   }
     OpenShare,      { Text File Unit                                       }
     Qread,          { Quick Readln                                         }
     Colunit,        { Local Macro Xlation                                  }
     Usersys;        { Users/Users.inf/users.sys maniupulation unit         }

(* ----------------------------------------------------------------------- *)

Const
 Author   = 'Hi.T.Moonweed';
 Progname = 'HiTSys';
 Version  = '0.10';
 VersDate = '06.08.93';

(* ----------------------------------------------------------------------- *)

Type
   pcbsysrec = record
    {1  }display:        char2;          {display on console?  -1 or 0}
    {3  }printer:        char2;          {print log?           -1 or 0}
    {5  }page_bell:      char2;          {bother sysop?        -1 or 0}
    {7  }alarm:          char2;          {caller alarm sound?  -1 or 0}
    {9  }sysop_next:     char;           {force sysop on next? 'N', 'X' or ' '}
    {10 }errcheck:       char2;          {error check/correcting modem? -1 or 0}
    {12 }graphics:       char;           {ansi graphics mode?   'Y','N','7'}
    {13 }nodechat:       char;           {node chat status 'U' or 'A'}
    {14 }openbps:        char5;          {BPS rate to open modem port at}
    {19 }connectbps:     char5;          {BPS connect rate or 'Local'}
    {24 }usernum:        integer;        {record number in user file}
    {26 }firstname:      char15;         {caller's first name}
    {41 }password:       char12;         {caller's password}
    {53 }time_on:        integer;        {when the user logged on in MINUTES}
    {55 }prev_used:      integer;        {minutes used in prev calls today, <0}
    {57 }time_logged:    char5;          {hh:mm time the user logged on}
    {62 }time_limit:     integer;        {maximum minutes allowed from PWRD}
    {64 }down_limit:     integer;        {daily download limit/1024 from PWRD}
    {66 }curconf:        byte;           {active conference when door opened}
    {67 }joined:         bitmap;         {areas user has been in}
    {72 }ydone:          bitmap;         {areas user has done 'Y' on}
    {77 }time_added:     integer;        {highest conference added time in mins}
    {79 }time_credit:    integer;        {upload/chat time credit in minutes}
    {81 }slanguage:      char4;          {language used, blank, .FRE etc}
    {85 }name:           char25;         {caller's full name}
    {110}sminsleft:      integer;        {minutes left when door opened}
    {112}snodenum:       byte;           {current node number}
    {113}seventtime:     char5;          {hh:mm event time}
    {118}seventactive:   char2;          {event time active? "-1" or "0 "}
    {120}sslide:         char2;          {slide event? "-1" or " 0"}
    {122}smemmsg:        single;         {memorized message number}
    {126}scomport:       char;           {com port number '0','1','2'}
    {127}fill99:         char2           {filler UNDOCUMENTED}
   End;

(* ----------------------------------------------------------------------- *)
Var
 PCBSYS:      Pcbsysrec;
 Sysfile: Buffered_file;
 TPAname:        Char15;
 x:                byte;
 Bollox:         String;
 ok:            Boolean;

(* ----------------------------------------------------------------------- *)
Procedure Endit;

Begin
 Ldisp('|02');
 Lnewline;
End;

(* ----------------------------------------------------------------------- *)

Procedure Copyright;
begin
 CLRSCR;
 pts1:=progname;
 pts2:=version;
 pts3:=versdate;
 pts4:=author;
 Ldisp('|10|S1 v|S2 (c) |S3 |S4');
 Lnewline;
 Ldisp('|02');
 Lnewline;
End;

(* ----------------------------------------------------------------------- *)
Procedure Usage;

Begin
 Ldisp('|09 Usage:-');
 Lnewline;
 Ldisp('|11  HiTSys <USERINF_PATH> <TPA_NAME> <NUMBER_OF_CONFERENCES>');
 Lnewline;
 Ldisp('|03  i.e. HiTSys X:\BBS\MAIN\ QMAIL4 104 ');
 Lnewline;
 Endit;
 Halt(99);
End;

(* ----------------------------------------------------------------------- *)
Procedure Nopcbsys;

begin
 pts1:=progname;
 Ldisp('|12 Unable to Locate |15PCBOARD.SYS |12please ensure |S1 is run');
 Lnewline;
 Ldisp('|12 from the PCBOARD directory!');
 Lnewline;
 Endit;
 Halt(98);
End;


(* ----------------------------------------------------------------------- *)
Procedure Corruptsys;

begin
 Ldisp('|12 Invalid Data in PCBOARD.SYS');
 Lnewline;
 Endit;
 Halt(97);
End;


(* ----------------------------------------------------------------------- *)

Begin
 Copyright;
{ Writeln(sizeof(userrec ));}
 If (PARAMSTR(1)='') OR (PARAMSTR(2)='') OR (PARAMSTR(3)='') Then Usage;
 USERINF_PATH:=PARAMSTR(1);
 USERS_PATH:=PARAMSTR(1);
 USERSYS_NAME:='USERS.SYS';
 NumberofConfs:=ATOI(PARAMSTR(3));
{ Writeln('Num: ',numberofConfs);}
{ numberofConfs:=71; }
 if Not Dos_exists('PCBOARD.SYS') then Nopcbsys;
 Bopen(sysfile,'PCBOARD.SYS',1,Sizeof(pcbsys));
 Bread(sysfile,pcbsys);
 Bclose(sysfile);
 pts1:='';
 pts1:=pcbsys.name;
 Delete_trailing_spaces(pts1);
 if (pts1[1]=' ') OR (PTS1='')  then Corruptsys;
 pts2:=Paramstr(2);
 Ldisp('|02Creating USERS.SYS for |09|S1|02 to run |09|S2|02... ');
 Fillchar(TPAname,15,#0);
 bollox:=paramstr(2);
 STOUPPER(Bollox);

 For x:=1 to length(bollox) do
 begin
  TPAname[x]:=bollox[x];
  if x=15 then x:=length(bollox);
 End;

 ok:=MakeUserSys(Pcbsys.usernum,TPAname);
 if not ok then ldisp('|10Error!|BEEP')
 ELSe Ldisp('|10Done!');
 Lnewline;
 Endit;
{ Writeln('Header+user: ',(sizeof(usersys_header) + sizeof(usersys_user))); }
End.

