Unit USERSYS;

(* ----------------------------------------------------------------------- *)
(* PCBoard USERS.SYS USERS.INF USERS                (c) 1993 Hi.T.Moonweed *)
(* ----------------------------------------------------------------------- *)
(* Manipulation of the following files                                     *)
(* USERS.                                                                  *)
(* PCBNDX.?                                                                *)
(* USERS.INF                                                               *)
(* USERS.SYS                                                               *)
(* ----------------------------------------------------------------------- *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(*                                                                         *)
(* ----------------------------------------------------------------------- *)

{                           COMPILER DIRECTIVES                             }

{$A+}                   { Word Align Data            }
{$S+}                   { Stack Checking Off         }
{$R-}                   { Range Checking Off         }
{$L-}                   { Local Debug shit off       }
{$D-}                   { Debug Info Off             }
{$V-}                   { Relaxed VarString Checking }
{$F+}                   { Force Far Calls!           }
{$B-}                   { Short Circuit Boolean      }
{$O-}                   { Overlays Off               }

Interface

Uses MiniCrt,        { Bios CRT Unit                                        }
     Dos,            { Dos Functions                                        }
     Tools,          { Various Utils                                        }
     DosMem,         { Improved Getmem                                      }
     Bufio,          { Buffered Input/Output                                }
     Mdosio,         { MSDos Input/Output                                   }
     OpenShare,      { Text File Unit                                       }
     Qread;          { Quick Readln                                         }
{     LinkList; }      { LinkList Unit                                        }

(* ----------------------------------------------------------------------- *)

Type
 Bool = Char;
 Char31 = Array[1..31] of char;

 UserInfHeaderRec145 = Record
  Version:              Word;
  NumConf:              Word;
  SizeofRec:            Word;
  SizeofConf:        Longint;
  NumofApps:            Word;
  TotRecSize:        Longint;
 End;

 ApptypeRecord145 = Record
  Name:               Char15;
  Version:              Word;
  SizeofRec:            Word;
  SizeofConfrec:        Word;
  Keyword:             Char9;
  TPAOffset:         Longint;
 End;

  PcbInfRec145 = Record
   Name:              Char25;
   MsgsRead:         Longint;
   MsgsLeft:         Longint;
  End;

  FlagPack = record
   Mailwaiting:         byte;
   COnfSysOp:           byte;
   Registered:          byte;
   Expired:             byte;
   ConfScan:            byte;
  End;


  userindexrec = record
   urec: word;
   name: char25;
  end;



  userrec = record
   {1  }name:          char25;
   {26 }city:          char24;
   {50 }passwd:        char12;         {no spaces allowed}
   {62 }busphone:      char13;
   {75 }phone:         char13;
   {88 }date:          char6;          {yymmdd of last call}
   {94 }time:          char5;          {hh:mm  of last call}
   {99 }expert:        char;           {pcboard expert status Y or N}
   {100}protocol:      char;           {X, C, Y, N}
   {101}pcbflags:      byte;           {space - reserved}
   {102}filedate:      char6;          {yymmdd of last file directory}
   {108}level:         byte;           {security level}
   {109}total_calls:   integer;        {number of times on system}
   {111}pagelen:       byte;           {page length}
   {112}uploads:       integer;        {number of uploads}
   {114}downloads:     integer;        {number of downloads}
   {116}downbytes:     double;         {daily download bytes so far}
   {124}usercomment:   char30;         {user entered comment field}
   {154}sysopcomment:  char30;         {sysop maintained comment field}
   {184}lastused:      integer;        {minutes used so far today}
   {186}expdate:       char6;          {yymmdd expiration date}
   {192}explevel:      byte;           {expired security level}
   {193}curconf:       byte;           {current conference number}
   {194}conferences:   bitmap;         {area registration 1-39 (5 bytes)}
   {199}expconf:       bitmap;         {expired conference registration}
   {204}scanconf:      bitmap;         {user configured scan conferences}
   {209}downtotal:     double;         {total bytes downloaded, all calls}
   {217}uptotal:       double;         {total bytes uploaded, all calls}
   {225}dead:          char;           {positive delete flag, Y or N}
   {226}lastread:      array[0..39] of single;
   {386}userinfptr:    longint;        {reserved for future use}
        reserve9:      Char9;
        AltHighConf:   Word;
   {total size: 400}
  end;

  InfFlagsrec = record
   Mail:      boolean;
   Sysop:     boolean;
   Regged:    boolean;
   Expire:    boolean;
   Scan:      boolean;
  End;

  UserSysHeaderRec145 = Record
   Version:         Word;
   Urec:         Longint;
   SizeFixed:       Word;
   NumAreas:        Word;
   NumBitFlags:     Word;
   SIzeBitFlags:    Word;
   AppName:       Char15;
   AppVersion:      Word;
   AppSizeFixed:    Word;
   AppSizeDynam:    Word;
   AppRecoffset: Longint;
   Dirty:           Char;
  End;

  DosDateRec =  Word;

  UserSysUserRec145 = Record
   Name:          Char25; {Null Terminated!}
   Null1:           Char;
   City:          Char24; {        ^       }
   Null2:           Char;
   Password:      Char12; {        ^       }
   Null3:           Char;
   BusPhone:      Char13; {        ^       }
   Null4:           Char;
   HomePhone:     Char13; {        ^       }
   Null5:           Char;
   LastOn:          Word; {Julian Date}
   LastTimeOn:     Char5;
   Null6:           Char;
   Expert:          Bool;
   Protocol:        Char;
   PackedFlags:     byte;
   LastScan:  DosDateRec;
   Seclevel:        Word; {Develop Doc Reckons Byte .. but its 2 Chars in File!}
   Timeson:         word;
   Pagelength:      char; { Why Char??? }
   Numuploads:      word;
   NumDownloads:    word;
   DailyLeech:   Longint;
   UserComment:   Char30; {Null terminated}
   Null7:           Char;
   SysopComment:  Char30; {       ^       }
   Null8:           Char;
   ElapsedTime:     word; { See Normal Sec Note }
   RegexpDate:      Word; {JULIAN}
   ExpiredSec:      word; { See Normal Security Note!}
   LastConf:        word;
   TotalDlBytes: Longint;
   TotalUpbytes: Longint;
   Delete:          bool;
   UserinfPtr:   Longint;
   reserved:       char9; {bytes 391-399 in users}
   MsgsRead:     Longint;
   MsgsLeft:     Longint;
  End;



(* ----------------------------------------------------------------------- *)

{ Public Vars }

Var

USERINF_PATH:                STRING;
USERS_PATH:                  STRING;
USERINF_NAME:                STRING;
USERSYS_PATH:                STRING;
USERSYS_NAME:                STRING;
NumberOfConfs:                 Word;
HeaderSize:                 Integer;
UserInf_header: UserInfHeaderRec145;
UserInf_headersize:            Word;
Usersys_header: UserSysHeaderRec145;
UserSys_user:     UserSysUSerRec145;
Apptype_rec:       ApptypeRecord145;
ConfrecLength:              Integer;
ExtconfrecLength:           integer;
(* ----------------------------------------------------------------------- *)

{ Procedure Declarations }
Procedure FindHeaderSize;
Procedure ReadIndex(whotofind: string; var userNo: integer);
Function getuserrec(var user: userrec; recn: word): Boolean;
Function LoadAppRec(Number: integer; Var App: ApptypeRecord145): Boolean;
Function LoadAppRecbyname(Name: char15; Var App: ApptypeRecord145): Boolean;
Function GetConfFLags(UserInfPtr: Word;
                      Var PCBStatic:  PcbInfRec145;
                      Var Mailwait:   Array of byte;
                      Var ConfSysop:  Array of byte;
                      Var Registered: Array of byte;
                      Var Expired:    Array of byte;
                      Var ConfScan:  Array of byte): Boolean;

Function GetStatic(UserInfPtr: Word; Var PCBstatic: PCBINfrec145): Boolean;
Function PutStatic(UserInfPtr: Word; PCBstatic: PCBINfrec145): Boolean;
Function GetInfConf(Conf: word;
                    UserinfPtr: Word;
                    Var InfFlags: infflagsRec;
                    Var Lastread: Longint): Boolean;
Procedure ReadSysHeader;
Procedure ReadSysUser;
Procedure DosDate2Norm(DDate: DosDateRec;
                       Var Days: Byte;
                       Var Months: Byte;
                       Var Years:  Byte);
Procedure NormDate2Dos(Var DDate: DosDaterec;
                       days,months,Years: Byte);
Procedure UserstoJulian(Var Julian: Word; UsersDate: char6);
Procedure DateToJulian(Var julian: Word; D,M,Y: Word);
Procedure JuliantoDate(Julian:Word; var D,M,Y: word);
Procedure UsersDate2Dos(Var DDate: DosDateRec; UsersDate: Char6);
Function MakeUserSys(Usernumber: Word; TPAName: Char15): Boolean;
(* ----------------------------------------------------------------------- *)
Implementation
(* ----------------------------------------------------------------------- *)
{ Private Vars }
Var
 Userinf_file: Buffered_file;
 Usersys_file: Buffered_file;
(* ----------------------------------------------------------------------- *)
 Procedure JuliantoDate(Julian:Word; var D,M,Y: word);

 var
  Remainder,Factored : longint;

 begin
  Dec(julian,1); {CDC uses a Different Root?}
  If Julian <= 58 then
  begin
   Y := 1900;
   If Julian <= 30 then
   begin
    M := 1;
    D := succ(Julian);
   end
   else
   begin
    M := 2;
    D := Julian - 30;
   end;
  end
  else
  begin
   Factored := 4*LongInt(Julian) - 233;
   Y := Factored div 1461;
   Remainder := (Factored mod 1461 div 4 * 5) + 2;
   M := Remainder div 153;
   D := succ((Remainder mod 153) div 5);
   Y := Y + 1900;
   If M < 10 then M := M + 3
   else
   begin
    M := M - 9;
    Inc(Y);
    end;
  end;
 end;

(* ----------------------------------------------------------------------- *)

 Procedure DateToJulian(Var julian: Word; D,M,Y: Word);

 var
    Temp : word;

 begin
  If  (Y=1900)
  and (M <= 2) then
  begin
   If M = 1 then Temp := pred(D)
   else Temp := D+30;
  end
  else
  begin
   If M > 2 then M := M - 3
   else
   begin
    M := M + 9;
    dec(Y);
   end;
   Y := Y - 1900;
   Temp := (1461*longint(Y) div 4) + (153*M+2) div 5 + D + 58;
  end;
  Julian := Temp+1;
 end;

(* ----------------------------------------------------------------------- *)
Procedure UserstoJulian(Var Julian: Word; UsersDate: char6);

var
 a: byte;
 yys,mms,dds: string[2];
 yy,mm,dd: word;
Begin
 yys:='  ';
 mms:='  ';
 dds:='  ';

 for a:= 1 to 2 do
 begin
  yys[a]:=usersdate[a];
  mms[a]:=Usersdate[a+2];
  dds[a]:=usersdate[a+4];
 End;

 yy:=atoi(yys)+1900;
 mm:=atoi(mms);
 dd:=atoi(dds);
{ Writeln('yyy-mmm-ddd');
 Writeln( yys,mms,dds);}
 Julian:=0;
 if (yy<>1980) AND (mm<>0) THEN DateToJulian(Julian,dd,mm,yy);
End;
(* ----------------------------------------------------------------------- *)


Function MakeUserSys(Usernumber: Word; TPAName: Char15): Boolean;

Var
 User: Userrec;
 ok:   boolean;
 TheTPA: ApptypeRecord145;
 InfStatic: PcbInfRec145;
 jword: Word;
 x: word;
 sysh: Dos_handle;
 infh: Dos_handle;
 n: integer;
 shitflags: infflagsRec;
 lastread: longint;
 seekofs: Longint;
 bitArray1: array[1..1000] of byte; {max 1000 confs!}
 bitArray2: array[1..125] of byte; {max 1000 confs!}
 bitArray3: array[1..125] of byte; {max 1000 confs!}
 bitArray4: array[1..125] of byte; {max 1000 confs!}
 bitArray5: array[1..125] of byte; {max 1000 confs!}
 TPABytes: Longint;
 tempstr: String;

Begin
 Makeusersys:=false;
 ok:=true;
 ok:=Getuserrec(User,Usernumber);
 if not ok then Exit;
 FindHeaderSize;
 ok:=LoadAppREcbyName(TPAName,TheTPA);
 if not ok then Exit;
 ok:=GetStatic(User.UserINfPtr,infstatic);
 With UserSys_Header Do
 Begin
  Version:=1450;
  Urec:=UserNumber;
  SizeFixed:=Sizeof(usersys_user);
  NumAreas:=numberofconfs+1;
  NumBitFlags:=7;
  SIzeBitFlags:=ConfrecLength;
  AppName:=TheTpa.name;
  AppVersion:=theTpa.version;
  AppSizeFixed:=TheTPA.SizeofRec;
  AppSizeDynam:=TheTpa.SizeofConfRec;
  AppRecoffset:=TheTpa.TpaOffset;
  Dirty:=#0;
 End;
 With UserSys_User Do
 Begin
  tempstr:=user.name;
  Delete_trailing_spaces(tempstr);
  Name:=User.name;
  if length(tempstr)<25 THEN name[length(tempstr)+1]:=#0;
  Null1:=#0;
  City:=USer.City;
  tempstr:=user.city;
  Delete_trailing_spaces(tempstr);
  if length(tempstr)<24 THEN city[length(tempstr)+1]:=#0;
  Null2:=#0;
  Password:=User.Passwd;
  tempstr:=user.passwd;
  Delete_trailing_spaces(tempstr);
  if length(tempStr)<12 THEN Password[Length(tempstr)+1]:=#0;
  Null3:=#0;
  BusPhone:=User.busphone;
{  tempstr:=user.busphone;
  Delete_trailing_spaces(tempstr);
  if length(tempStr)<13 THEN busphone[Length(tempstr)+1]:=#0; }
  Null4:=#0;
  HomePhone:=User.phone;
{  tempstr:=user.phone;
  Delete_trailing_spaces(tempstr);
  if length(tempStr)<13 THEN homephone[Length(tempstr)+1]:=#0; }
  Null5:=#0;
  UserstoJulian(jword,user.date);
  LastOn:=jword;
  LastTimeOn:=User.time;
  Null6:=#0;
  Expert:=#0;
  if user.Expert='Y' then Expert:=#1;
  Protocol:=user.protocol;
  PackedFlags:=user.pcbflags;
  UsersDate2Dos(jword,user.filedate);
  LastScan:=jword;
  Seclevel:=User.level;
  Timeson:=user.total_calls;
  Pagelength:=chr(user.pagelen);
  Numuploads:=user.uploads;
  NumDownloads:=User.downloads;
{  Writeln('Doing Daily D/L'); }
{  Writeln(User.NAme); }
  DailyLeech:=dtol(user.downbytes);
  UserComment:=user.usercomment;
{  tempstr:=user.usercomment;
  Delete_trailing_spaces(tempstr);
  if length(tempStr)<31 THEN Usercomment[Length(tempstr)+1]:=#0; }
  Null7:=#0;
  SysopComment:=user.sysopComment;
{  tempstr:=user.sysopcomment;
  Delete_trailing_spaces(tempstr);
  if length(tempStr)<31 THEN sysopcomment[Length(tempstr)+1]:=#0; }
  Null8:=#0;
  ElapsedTime:=user.lastused;
  jword:=0;
  UserstoJulian(jword,user.expdate);
  RegexpDate:=jword;
{  ExpiredSec:=user.explevel; }
  ExpiredSec:=User.level;
  LastConf:=user.curconf;
{  Writeln('Doing Total D/L'); }
{  Writeln(dtof(user.downtotal)); }
  TotalDlBytes:=dtol(user.downtotal);

{  Writeln(totalDLbytes); }
{  Writeln('Doing Total U/L'); }
  TotalUpbytes:=dtol(user.uptotal);
{  Writeln(totalUpbytes); }
  Delete:=#0;
  if user.dead='Y' then Delete:=#1;
  UserinfPtr:=user.userinfptr;
  reserved:=User.Reserve9;
  MsgsRead:=InfStatic.MsgsRead;
  MsgsLeft:=InfStatic.MsgsLeft;
 End;

 if Dos_exists(usersys_name) then Dos_unlink(usersys_name);
{ Writeln('Unlinked!');}
 sysh:=Dos_create(usersys_name);
{ Writeln('Created!');}
 Dos_close(sysh);
 Sysh:=Dos_open(usersys_name,Open_Write);
 dos_Write(sysh,usersys_header,Sizeof(usersys_header));
 dos_Write(sysh,usersys_user,Sizeof(usersys_user));
 for x:= 1 to (numberofConfs+1) do
 begin
  if X<=40 then
  begin
   lastread:=STOL(USER.LASTread[x-1]);
   Dos_write(sysh,Lastread,4);
   {Writeln(lastread);}
  end;
  if X>40 then
  begin
   ok:=GetinfConf(x-1,user.userinfptr,shitflags,lastread);
   Dos_write(sysh,lastread,4);
   {Writeln(lastread);}
  End;
 end;
 ok:=GetConfFlags(user.userinfPtr,infstatic,bitarray1,bitarray2,bitarray3,bitarray4,bitarray5);
 { Registered }
 Dos_write(sysh,user.conferences,5);
 Dos_write(sysh,Bitarray3,Extconfreclength);
 { Expired Registered }
 Dos_write(sysh,user.expconf,5);
 Dos_write(sysh,Bitarray4,Extconfreclength);
 { Scan Confs }
 Dos_write(sysh,user.scanconf,5);
 Dos_write(sysh,Bitarray5,Extconfreclength);
 { Conf Sysop }
 Dos_write(sysh,bitarray2,Confreclength);
 { Conf Mail }
 Dos_write(sysh,bitarray1,Confreclength);
 Fillchar(bitarray1,sizeof(bitarray1),#0);
 { Joined }
 Dos_write(sysh,bitarray1,confreclength);
 { Scanned }
 Dos_write(sysh,bitarray1,confreclength);
 {---}
 infh:=dos_open(USERinf_name,open_read);
 seekofs:=Userinf_HeaderSize+((user.userinfPtr-1) * (UserInf_Header.Totrecsize));
 Inc(seekofs,Sizeof(infstatic));
 Inc(seekofs,userinf_header.sizeofConf);
 Dos_lseek(infh,seekofs,seek_start);
{ TPAbytes:=TheTPA.Sizeofrec+TheTpa.sizeofconfRec;}
 TPAbytes:=Userinf_header.totrecsize-THETpa.TPaoffset;
{ Writeln('TPAbytes: ',tpabytes);
 Writeln('Totsize: ',Userinf_header.totrecsize);
 Writeln('TPAofs: ',TheTPA.TPAoffset);}
 n:=Dos_read(infh,bitarray1,tpabytes);
{ Writeln('Bytes Read: ',n);}
 dos_close(infh);
 {---}
 dos_write(sysh,bitarray1,tpabytes);
 Dos_close(sysh);
 makeusersys:=true;
End;

(* ----------------------------------------------------------------------- *)
{Procedure ReadUserSys(var updated: Boolean);

Var
 ok: Boolean;
 blah: PcbinfRec145;
 x: longint;

Begin

 ReadsysHeader;
 updated:=true;
 If Usersys.Dirty<>#0 then
 BEgin
  updated:=false;
  Exit;
 End;
 ReadsysUser;
 FindHeaderSize;
 ok:=getstatic(usersys_user.UserInfPtr,Blah);
 if (Blah.MsgsReaD<>usersys_user.MsgsRead) OR (blah.Msgsleft<>Usersys_user.MsgsLeft) THEN
 Begin
  With Blah do
   Msgsread:=Usersys_user.msgsread;
   Msgsleft:=Usersys_user.msgsleft;
  End;
  ok:=putstatic(usersys_user.UserinfPtr,Blah);
 End;
 For x:=}

(* ----------------------------------------------------------------------- *)
Procedure DosDate2Norm(DDate: DosDateRec;
                       Var Days: Byte;
                       Var Months: Byte;
                       Var Years:  Byte);

Begin
 Days:=DDATE AND 31;
 Months:=(DDate AND 480) SHR 5;
 Years:=((DDate AND 65024) SHR 9)+80;
End;

(* ----------------------------------------------------------------------- *)
Procedure UsersDate2Dos(Var DDate: DosDateRec; UsersDate: Char6);

var
 a: byte;
 yys,mms,dds: string[2];
 yy,mm,dd: word;
Begin
 yys:='  ';
 mms:='  ';
 dds:='  ';

 for a:= 1 to 2 do
 begin
  yys[a]:=usersdate[a];
  mms[a]:=Usersdate[a+2];
  dds[a]:=usersdate[a+4];
 End;

 yy:=atoi(yys);
 mm:=atoi(mms);
 dd:=atoi(dds);

 normDate2Dos(DDate,dd,mm,yy);

End;

(* ----------------------------------------------------------------------- *)
Procedure NormDate2Dos(Var DDate: DosDaterec;
                       days,months,Years: Byte);

Begin
{ Writeln('Norm2Dos = Years ',years);}

 Ddate:=0;
 if Years=0 then
 begin
{  WRITELN('ZERO DATE!'); }
  exit;
 End;
 Dec(years,80);
 Inc(DDate,(Years SHL 9));
 INC(DDate,(Months SHL 5));
 INC(DDAte,(days));
End;

(* ----------------------------------------------------------------------- *)
Procedure ReadSysHeader;

Begin
 Cons_path(usersys_name,usersys_path,'USERS.SYS');
 Bopen(Usersys_file,Usersys_name,1,Sizeof(Usersys_header));
 Bread(Usersys_file,Usersys_header);
 Bclose(usersys_file);
End;

(* ----------------------------------------------------------------------- *)
Procedure ReadSysUser;

Var
 sysfh: Dos_handle;
 n:        Integer;

Begin
 sysfh := dos_open(usersys_name,open_update);
 Dos_lseek(sysfh,Sizeof(usersys_header),Seek_start);
 n:=dos_read(sysfh,usersys_user,Sizeof(usersys_user));
 Dos_close(sysfh);
End;
(* ----------------------------------------------------------------------- *)
Function sysLastRead(COnfNum: word): Longint;

Var
 sysfh: Dos_handle;
 n:        Integer;
 seekto:   Longint;
 aLong:    Longint;

Begin
 syslastRead:=0;
 seekTo:=(Sizeof(usersys_header)+sizeof(usersys_user))+((Confnum+1)*4);
 sysfh:=Dos_open(usersys_name,open_update);
 Dos_lseek(sysfh,seekto,seek_start);
 n:=Dos_read(sysfh,aLong,4);
 syslastread:=along;
End;


(* ----------------------------------------------------------------------- *)

Procedure ReadIndex(whotofind: string; var userNo: integer);
Var
   fd:               dos_handle;
   rec,user_ix:    userindexrec;
   count:                  byte;
   NDX_file_full:        string;
   c_user_name:          char25;
   ixfd:          buffered_file;
   max:                    byte;

begin
   USERNO:=-1;
   STOUPPER(whotofind);
   fillchar(c_user_name,sizeof(c_user_name),' ');

   max:=length(whotofind);
   if max>25 then max:=25;
   for count := 1 to max do c_user_name[count]:=whotofind[count];

   cons_path(dos_name,users_path,'PCBNDX.' + c_user_name[1]);
   bopen(ixfd,dos_name,150,sizeof(user_ix));
   if berr then exit;

   user_ix.urec := 1;
   user_ix.name := '1234567890123456789012345';
   while (user_ix.name <> c_user_name) and (not berr) do
      bread(ixfd,user_ix);
   bclose(ixfd);

   if (user_ix.name <> c_user_name) then
    userNo:=-1
   else
    userNo:=user_ix.urec;
end;


(* ------------------------------------------------------------------------ *)
Function getuserrec(var user: userrec; recn: word): Boolean;

var
   fd:  dos_handle;
   n:   integer;
   userfile: string;
   error: Boolean;

begin
   error:=false;
   getuserrec:=true;
   Cons_path(userfile,Users_path,'Users.');
   fd := dos_open(USERFILE,open_update);
   if fd = dos_error then error:=false;
   if NOT Error then
   begin
    dos_rseek(fd,recn-1,sizeof(user),seek_start);
    n := dos_read(fd,user,sizeof(user));
    if n <> sizeof(user) then getuserrec:=false;
    dos_close(fd);
   end;
   if Error then Getuserrec:=false;
end;



(* ------------------------------------------------------------------------ *)
  Procedure FindHeaderSize;


  Begin
   Cons_path(userinf_name,userinf_path,'USERS.INF');
   Bopen(userinf_file,Userinf_name,1,Sizeof(UserInf_header));
   Bread(userinf_file,UserInf_header);
   Bclose(userinf_file);
   Userinf_headersize:=Sizeof(UserInf_Header)+(Userinf_header.NumofApps * Sizeof(Apptype_rec));
   ConfrecLength:=(NumberOfConfs DIV 8);
   if (NumberOfConfs MOD 8) <> 0 THEN INC(ConfrecLength);
   if ConfRecLength<5 then ConfrecLength:=5;
   ExtconfrecLength:=ConfRecLength-5;
  End;

(* ----------------------------------------------------------------------- *)
 Function LoadAppRec(Number: integer; Var App: ApptypeRecord145): Boolean;

 Var
  Error: Boolean;
  fd: Dos_handle;
  x:     Integer;

 Begin
  Error:=false;
  LoadAppRec:=true;
  fd := dos_open(USERinf_name,open_update);
  if fd = dos_error then Error:=TRue;
  if not Error then
  begin
   Dos_lseek(fd,Sizeof(userinf_header),Seek_start);
   Bprepare(userinf_file,fd,100,sizeof(app));
   if Berr then Error:=true;
   if Not Error then
   begin
{    x:=Btell(userinf_file); }
{    Writeln(x);             }
    Bseek(userinf_file,(number-1));
    Bread(userinf_file,App);
    Bclose(userinf_file);
   End;
  end;
  if Error OR Berr then Loadapprec:=false;
 end;

(* ----------------------------------------------------------------------- *)
 Function LoadAppRecbyName(Name: char15; Var App: ApptypeRecord145): Boolean;

 Var
  Error: Boolean;
  fd: Dos_handle;
  x:     Integer;
  s,t:    String;

 Begin
  Error:=false;
  LoadAppRecbyname:=true;
  s:=name;
  Replace_string(s,' ',#0);
  for x:=1 to 15 do name[x]:=s[x];



  fd := dos_open(USERinf_name,open_update);
  if fd = dos_error then Error:=TRue;
  if not Error then
  begin
   Dos_lseek(fd,Sizeof(userinf_header),Seek_start);
   Bprepare(userinf_file,fd,100,sizeof(app));
   if Berr then Error:=true;
   if Not Error then
   begin
{    x:=Btell(userinf_file); }
{    Writeln(x);             }
{    Bseek(userinf_file,(number-1));}
    while (App.name<> NAME) AND (NOT BERR) do Bread(userinf_file,App);
    Bclose(userinf_file);
   End;
  end;
  if Error OR Berr then Loadapprecbyname:=false;
 end;

(* ----------------------------------------------------------------------- *)
  Function GetStatic(UserInfPtr: Word; Var PCBstatic: PCBINfrec145): Boolean;

Var
 Seekofs: Longint;
 fd: Dos_handle;
 n: integer;
Begin

   GetStatic:=false;
   fd := dos_open(USERinf_name,open_update);
   if fd = dos_error then exit;

   seekofs:=Userinf_HeaderSize+((userinfPtr-1) * (UserInf_Header.Totrecsize));
   dos_lseek(fd,Seekofs,seek_start);

   n := dos_read(fd,pcbstatic,sizeof(pcbstatic));
   if n <> sizeof(pcbstatic) then exit;
   dos_close(fd);
   GetStatic:=true;
End;

(* ----------------------------------------------------------------------- *)

  Function PutStatic(UserInfPtr: Word; PCBstatic: PCBINfrec145): Boolean;

Var
 Seekofs: Longint;
 fd: Dos_handle;
 n: integer;
Begin

   PutStatic:=false;
   fd := dos_open(USERinf_name,open_update);
   if fd = dos_error then exit;

   seekofs:=Userinf_HeaderSize+((userinfPtr-1) * (UserInf_Header.Totrecsize));
   dos_lseek(fd,Seekofs,seek_start);

   dos_Write(fd,pcbstatic,sizeof(pcbstatic));
   dos_close(fd);
   PutStatic:=true;
End;
(* ----------------------------------------------------------------------- *)
  Function GetConfFLags(UserInfPtr: Word;
                        Var PCBStatic:  PcbInfRec145;
                        Var Mailwait:   Array of byte;
                        Var ConfSysop:  Array of byte;
                        Var Registered: Array of byte;
                        Var Expired:    Array of byte;
                        Var ConfScan:   Array of byte): Boolean;

  Var
   Seekofs: Longint;
   fd:      Dos_handle;
   n:       Integer;

  Begin
   GetConfFlags:=false;
   fd := dos_open(USERinf_name,open_update);
   if fd = dos_error then exit;

   seekofs:=Userinf_HeaderSize+((userinfPtr-1) * (UserInf_Header.Totrecsize));
   dos_lseek(fd,Seekofs,seek_start);

   n := dos_read(fd,pcbstatic,sizeof(pcbstatic));
   if n <> sizeof(pcbstatic) then exit;
   N:= Dos_read(fd,Mailwait,Confreclength);
   if n <> ConfrecLength then exit;
   N:= Dos_read(fd,Confsysop,Confreclength);
   if n <> ConfrecLength then exit;
   N:= Dos_read(fd,registered,EXtConfrecLength);
   if n <> extConfrecLength then exit;
   N:= Dos_read(fd,Expired,extConfreclength);
   if n <> extConfrecLength then exit;
   N:= Dos_read(fd,Confscan,extConfreclength);
   if n <> extConfrecLength then exit;
   dos_close(fd);
   GetConfFlags:=true;
  end;


(* ----------------------------------------------------------------------- *)
Function GetInfConf(Conf: word;
                    UserinfPtr: Word;
                    Var InfFlags: infflagsRec;
                    Var Lastread: Longint): Boolean;

var
 PCBStatic:  PcbInfRec145;
 Mailwait:   byte;
 ConfSysop:  byte;
 Registered: byte;
 Expired:    byte;
 Confscan:   byte;
 x:          longint;
 y:          byte;
 fd:         dos_handle;
 seekofs:    longint;
 n:          Integer;
 test:       string;


begin
 GetinfConf:=false;
 if Conf<40 Then Exit;
 fd := dos_open(USERinf_name,open_update);
 if fd = dos_error then exit;
 seekofs:=Userinf_HeaderSize+((userinfPtr-1) * (UserInf_Header.Totrecsize));
 Inc(seekofs,Sizeof(pcbstatic));
 x:=seekofs;
 INC(seekofs,((CONF-39) DIV 8));
 IF ((conf-39) Mod 8)<>0 Then Inc(seekofs);
 dos_lseek(fd,Seekofs,seek_start);
 n:=Dos_read(fd,mailwait,1);
 inc(seekofs,Confreclength);

 dos_lseek(fd,Seekofs,seek_start);
 n:=Dos_read(fd,confsysop,1);
 inc(seekofs,Confreclength);

 dos_lseek(fd,Seekofs,seek_start);
 n:=Dos_read(fd,registered,1);
 Inc(seekofs,ExtConfRecLength);

 dos_lseek(fd,Seekofs,seek_start);
 n:=Dos_read(fd,expired,1);
 Inc(seekofs,ExtConfRecLength);

 dos_lseek(fd,Seekofs,seek_start);
 n:=Dos_read(fd,Confscan,1);

 y:=(Conf-39) MOD 8;

 With Infflags do
 Begin
  Mail:=Getbit(Mailwait,y);
  Sysop:=Getbit(ConfSysOp,y);
  Regged:=Getbit(Registered,y);
  Expire:=Getbit(EXpired,y);
  Scan:=Getbit(Confscan,y);
 End;

 seekofs:=x+(2*Confreclength)+(3*extconfreclength)+((Conf-40)*4);
{ inc(seekofs,conf); }

 Dos_lseek(fd,seekofs,seek_start);
 n:=Dos_Read(fd,lastread,sizeof(lastread));
 Dos_close(fd);
 GetinfConf:=true;
End;




(* ----------------------------------------------------------------------- *)
End.
(* ----------------------------------------------------------------------- *)
